﻿Imports System.ComponentModel

Public Class Form1

    Dim motherSource As New BindingList(Of SourceItem)
    Dim filteredSource As New BindingList(Of SourceItem)

    ''' <summary>
    ''' form init
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'init the mother source
        motherSource.Add(New SourceItem("group A", "item 1", "AAA"))
        motherSource.Add(New SourceItem("group A", "item 2", "BBB"))
        motherSource.Add(New SourceItem("group A", "item 3", "BBB"))
        motherSource.Add(New SourceItem("group A", "item 4", "BBB"))
        motherSource.Add(New SourceItem("group B", "item 5", "AAA"))
        motherSource.Add(New SourceItem("group B", "item 6", "BBB"))
        motherSource.Add(New SourceItem("group B", "item 7", "BBB"))
        motherSource.Add(New SourceItem("group B", "item 8", "BBB"))

        'init the filtered source
        For Each item As SourceItem In motherSource
            filteredSource.Add(item)
        Next

        'link the grid to the filtered source
        UltraGrid1.DataSource = filteredSource

        'row colors
        Dim currentBand = UltraGrid1.DisplayLayout.Bands(0)
        currentBand.Layout.Override.RowAppearance.BackColor = Color.White
        currentBand.Layout.Override.RowAlternateAppearance.BackColor = Color.LightYellow
    End Sub

    ''' <summary>
    ''' remove button
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub UltraButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UltraButton1.Click
        'stop ultragrid refresh
        UltraGrid1.BeginUpdate()
        UltraGrid1.SuspendRowSynchronization()
        UltraGrid1.SuspendLayout()

        'udpate the datasource
        filteredSource.Clear()
        'keep only item with filterProperty = BBB
        For Each item As SourceItem In motherSource
            If item.FilterProperty.Equals("BBB") Then
                filteredSource.Add(item)
            End If
        Next

        'resume refresh
        UltraGrid1.ResumeRowSynchronization()
        UltraGrid1.ResumeLayout()
        UltraGrid1.EndUpdate()


        'set the groupby manually
        Dim currentBand = UltraGrid1.DisplayLayout.Bands(0)
        currentBand.SortedColumns.Clear()
        currentBand.SortedColumns.Add("GroupName", False, True)
    End Sub
End Class
